package asw.asw865.prodotti;

import java.util.*; 

public class GestioneProdottiRepository {

	private static GestioneProdottiRepository instance; 
	
	public synchronized static GestioneProdottiRepository getInstance() {
		if (instance==null) {
			instance = new GestioneProdottiRepository(); 
		}
		return instance; 
	}
	
	private Map<String,Prodotto> prodotti; 
	
	private GestioneProdottiRepository() {
		this.prodotti = new HashMap<String,Prodotto>(); 
		this.prodotti.put("101", new Prodotto("101", "Prodotto #101", 1000));
		this.prodotti.put("102", new Prodotto("102", "Prodotto #102", 1200));
	}
	
	public Prodotto aggiungiProdotto(Prodotto p) {
		prodotti.put(p.getId(), p);
		return p; 
	}
	
	public Prodotto trovaProdotto(String id) {
		return prodotti.get(id); 
	}
	
	public Prodotto cancellaProdotto(String id) {
		return prodotti.remove(id); 
	}
	
	public Collection<Prodotto> tuttiProdotti() {
		return prodotti.values(); 
	}
	
}
