package asw.asw865.prodotti;

import javax.ws.rs.*;
import javax.ws.rs.core.*;

import java.net.URI;
import java.util.ArrayList;
import java.util.Collection; 

import javax.servlet.http.HttpServletResponse;

@Path("/prodotti")
@Produces({MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON, MediaType.TEXT_XML})
@Consumes(MediaType.APPLICATION_FORM_URLENCODED)
public class ProdottoContainer {
    @Context
    private UriInfo context;
    
    private GestioneProdottiRepository repository; 

    public ProdottoContainer() {
    	this.repository = GestioneProdottiRepository.getInstance(); 
    } 

    /* GET: Restituisce l'elenco di tutti i prodotti */
    @GET
    public Collection<Prodotto> getProdotti() {
    	Collection<Prodotto> prodotti = new ArrayList<Prodotto>(); 
    	prodotti.addAll(repository.tuttiProdotti()); 
    	return prodotti;  
    }


    /* POST: Aggiunge un nuovo prodotto */
    @POST
    public Response postProdotto(
			@FormParam("id") String id,
			@FormParam("descrizione") String descrizione,
			@FormParam("prezzo") int prezzo,
			@Context HttpServletResponse servletResponse
    		) {
    	Prodotto p = new Prodotto(id, descrizione, prezzo);
    	repository.aggiungiProdotto(p);
    	
		URI uri = context.getAbsolutePathBuilder().path(id).build();
		return Response.created(uri).build();
    }

}