package asw.asw865.prodotti;

import javax.ws.rs.*;
import javax.ws.rs.core.*;

@Path("/prodotti/{id}")
public class ProdottoResource {
	@Context
	private UriInfo uriInfo;
	
    private GestioneProdottiRepository repository; 

    public ProdottoResource() {
    	this.repository = GestioneProdottiRepository.getInstance(); 
    } 

    /* GET: Cerca un prodotto */
    @GET 
    @Produces({MediaType.APPLICATION_XML, MediaType.APPLICATION_JSON, MediaType.TEXT_XML})
    public Prodotto getProdotto(@PathParam("id") String id) {
    	Prodotto p = repository.trovaProdotto(id); 
    	if (p==null) {
    		String errorMessage = "Prodotto with id: " + id +  " not found";
    		throw new WebApplicationException(Response.status(404).
    			    entity(errorMessage).type("text/plain").build());
    	}
    	return p;  
    }

    /* DELETE: Cancella un prodotto */
    @DELETE 
    public Prodotto deleteProdotto(@PathParam("id") String id) {
    	Prodotto p = repository.cancellaProdotto(id); 
    	if (p==null) {
    		String errorMessage = "Prodotto with id: " + id +  " not found";
    		throw new WebApplicationException(Response.status(404).
    			    entity(errorMessage).type("text/plain").build());
    	}
    	return p; 
    }

}