package asw.asw865.prodotti.client;

import java.util.logging.Logger;

import asw.asw865.prodotti.Prodotto;
import asw.util.logging.AswLogger;

public class Main {

	/* logger */ 
	private static Logger logger = AswLogger.getInstance().getLogger("asw.asw865.prodotti.client"); 
	
	/* proxy al servizio per la gestione prodotti */ 
	GestioneProdottiServiceProxy service; 

	public static void main(String[] args) {
		new Main() . run(); 
	}
	
	public Main() {		
		this.service = new GestioneProdottiServiceProxy(); 
	}
	
	private void run() {
		
		/* svolge un po' di attivit sui prodotti */ 
		
		logger.info("get prodotti as string: " + service.getProdottiAsJsonString());
		logger.info("get prodotti as list: " + service.getProdotti());
		
		logger.info("get prodotto 101 as string: " + service.getProdottoAsJsonString("101"));
		logger.info("get prodotto 101 as object: " + service.getProdotto("101"));

		Prodotto p = new Prodotto("103", "Prodotto #103", 3000); 
		logger.info("post prodotto: " + p);
		service.addProdotto(p);
		
		logger.info("get prodotto 103 as object: " + service.getProdotto("103"));

		logger.info("get prodotti as list: " + service.getProdotti());

		logger.info("delete prodotto 103");
		service.deleteProdotto("103");

		logger.info("get prodotti as list: " + service.getProdotti());
		
		logger.info("get prodotto 103 as object: " + service.getProdotto("103"));

		service.close(); 
		
	}
	
}